'=====================================================================================
'Name: File Counter
'Version: 1.1
'Description:
'Use this script to count files (with a specific pattern) or folders in a specific
'folder with or without it's subfolders.

'New in this version:
'The ability to count the number of folders inside the specified folder.

'Author: ZheepmeiZter
'Contact: zheepmeizter@hotmail.com

'Tested on: Serious Samurize v1.50 on Microsoft Windows XP Home Edition

'You are allowed to redistribute this Zip-file only if it contains all of it's files:
'- File Counter ReadMe.txt
'- File Counter.vbs
'And if you leave this section of the files intact.
'=====================================================================================

Function FileCounterIncSub(Pattern, Path)
  Dim FSO, TotalLines, X, TmpFile, TotalFileCount

  X = 0
  TotalFileCount = 0

  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set Fldr = FSO.GetFolder(Path)

  FilesList = Split(GenerateAllFolderInformation(Fldr, 1, 1), "\n", -1, 1)

  TotalLines = UBound(FilesList)

  If Pattern <> "" Then
    Do While X < TotalLines
      X = X + 1
      TmpFile = Right(FilesList(X), 5)
     If Instr(TmpFile, Pattern) Then
        TotalFileCount = TotalFileCount + 1
      End If
    Loop
    FileCounterIncSub = TotalFileCount
  Else
    FileCounterIncSub = TotalLines
  End If
End Function

Function FileCounterExclSub(Pattern, Path)
  Dim FSO, TotalLines, X, TmpFile, TotalFileCount

  X = 0
  TotalFileCount = 0

  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set Fldr = FSO.GetFolder(Path)

  FilesList = Split(GenerateAllFolderInformation(Fldr, 1, 0), "\n", -1, 1)

  TotalLines = UBound(FilesList)

  If Pattern <> "" Then
    Do While X < TotalLines
      X = X + 1
      TmpFile = Right(FilesList(X), 5)
     If Instr(TmpFile, Pattern) Then
        TotalFileCount = TotalFileCount + 1
      End If
    Loop
    FileCounterExclSub = TotalFileCount
  Else
    FileCounterExclSub = TotalLines
  End If
End Function

Function FolderCounterIncSub(Path)
  Dim FSO, TotalLines

  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set Fldr = FSO.GetFolder(Path)

  FoldersList = Split(GenerateAllFolderInformation(Fldr, 0, 1), "\n", -1, 1)

  TotalLines = UBound(FoldersList)

  FolderCounterIncSub = TotalLines
End Function

Function FolderCounterExclSub(Path)
  Dim FSO, TotalLines

  Set FSO = CreateObject("Scripting.FileSystemObject")
  Set Fldr = FSO.GetFolder(Path)

  FoldersList = Split(GenerateAllFolderInformation(Fldr, 0, 0), "\n", -1, 1)

  TotalLines = UBound(FoldersList)

  FolderCounterExclSub = TotalLines
End Function

Function GenerateAllFolderInformation(Folder, Mode, SecMode)
  Dim S
  Dim SubFolders
  Dim SubFolder
  Dim Files
  Dim File

  Set Files = Folder.Files

  If Mode = 1 Then
    If Files.Count <> 0 Then
      For Each File In Files
        S = S & "\n" & File.Name
      Next
    End If
  ElseIf Mode = 0 Then
    Set SubFolders = Folder.SubFolders
    For Each SubFolder In SubFolders
      S = S & "\n" & SubFolder.Name
    Next
  End If

  If SecMode = 1 Then
    Set SubFolders = Folder.SubFolders

    If SubFolders.Count <> 0 Then
      For Each SubFolder In SubFolders
        S = S & GenerateAllFolderInformation(SubFolder, Mode, SecMode)
      Next
    End If
  End If

  GenerateAllFolderInformation = S
End Function